import org.junit.Test;
import static org.junit.Assert.*;

public class LifeTestRechterRand {

    @Test
    public void createNewCell() {

        // Arrange: drei lebende Zellen
        Life l = new Life();
        l.setAlive(4, 0);
        l.setAlive(4, 1);
        l.setAlive(4, 2);
        l.printWelt();

        // Act: Berechnung der Folgegeneration
        ILife nextGen = l.nextGeneration();
        nextGen.printWelt();

        // Assert: Rasterpunkt mit drei Nachbarn sollte jetzt leben
        assertTrue(nextGen.isAlive(4, 1));
    }

    @Test
    public void destroyLonelyCell() {

        // Arrange: drei lebende Zellen
        Life l = new Life();
        l.setAlive(4, 1);

        // Act: Berechnung der Folgegeneration
        ILife nextGen = l.nextGeneration();
        nextGen.printWelt();

        // Assert: Rasterpunkt ohne Nachbarn sollte jetzt tot sein
        assertTrue(nextGen.isDead(4, 1));
    }


    @Test
    public void keepAliveCell() {

        // Arrange: drei lebende Zellen
        Life l = new Life();
        l.setAlive(4, 0);
        l.setAlive(4, 1);
        l.setAlive(4, 2);
        l.printWelt();

        // Act: Berechnung der Folgegeneration
        ILife nextGen = l.nextGeneration();
        nextGen.printWelt();

        // Assert: Rasterpunkt mit drei Nachbarn sollte jetzt leben
        assertTrue(nextGen.isAlive(4, 1));
    }


    @Test
    public void destroyCrowdedCell() {

        // Arrange: drei lebende Zellen
        Life l = new Life();
        l.setAlive(4, 0);
        l.setAlive(3, 0);
        l.setAlive(4, 1);
        l.setAlive(4, 2);
        l.setAlive(3, 1);
        l.printWelt();

        // Act: Berechnung der Folgegeneration
        ILife nextGen = l.nextGeneration();
        nextGen.printWelt();

        // Assert: Rasterpunkt mit drei Nachbarn sollte jetzt leben
        assertTrue(nextGen.isDead(4, 1));
        assertTrue(nextGen.isDead(3, 1));
    }


}

